"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SingleCheckbox = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormCheckbox = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/collections/Form/FormCheckbox.js"));

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _helpers = require("../helpers/helpers");

var _multipleChoiceList = _interopRequireDefault(require("./multiple-choice-list"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _excluded = ["input", "isReadOnly", "isDisabled", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "FormFieldGridProps", "HelperTextProps"],
    _excluded2 = ["options"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var SingleCheckbox = function SingleCheckbox(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
    type: 'checkbox'
  })),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      HelperTextProps = _useFieldApi.HelperTextProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var invalid = (0, _helpers.validationError)(meta, validateOnMount);
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({
    helperText: (0, _helpers.validationWarning)(meta, validateOnMount) || helperText,
    HelperTextProps: HelperTextProps
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_FormCheckbox["default"], (0, _extends2["default"])({}, input, {
    required: isRequired,
    onChange: function onChange(_event, data) {
      input.onChange({
        target: data,
        type: 'checkbox'
      });
    },
    disabled: isDisabled || isReadOnly
  }, rest, {
    label: label,
    error: invalid && {
      content: meta.error || meta.submitError,
      pointing: 'left'
    }
  })));
};

exports.SingleCheckbox = SingleCheckbox;
SingleCheckbox.propTypes = {
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,

  /** Sub components customization API */
  FormFieldGridProps: _propTypes["default"].object,
  HelperTextProps: _propTypes["default"].object
};

var Checkbox = function Checkbox(_ref) {
  var options = _ref.options,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded2);
  return options ? /*#__PURE__*/_react["default"].createElement(_multipleChoiceList["default"], (0, _extends2["default"])({
    options: options
  }, props)) : /*#__PURE__*/_react["default"].createElement(SingleCheckbox, props);
};

Checkbox.propTypes = {
  options: _propTypes["default"].array,

  /** Sub components customization API */
  FormFieldGridProps: _propTypes["default"].object,
  HelperTextProps: _propTypes["default"].object
};
Checkbox.defaultProps = {
  FormFieldGridProps: {},
  HelperTextProps: {}
};
var _default = Checkbox;
exports["default"] = _default;