"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Button/Button.js"));

var _Header = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Header/Header.js"));

var _formTemplate = _interopRequireDefault(require("@data-driven-forms/common/form-template"));

var _excluded = ["children"],
    _excluded2 = ["children"],
    _excluded3 = ["children"],
    _excluded4 = ["children"],
    _excluded5 = ["label", "children", "buttonType", "variant"];

var Form = function Form(_ref) {
  var children = _ref.children,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement("form", (0, _extends2["default"])({
    className: "ui form",
    noValidate: true
  }, props), children);
};

Form.propTypes = {
  children: _propTypes["default"].node
};

var Description = function Description(_ref2) {
  var children = _ref2.children,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);
  return /*#__PURE__*/_react["default"].createElement("span", props, children);
};

Description.propTypes = {
  children: _propTypes["default"].node
};

var Title = function Title(_ref3) {
  var children = _ref3.children,
      props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded3);
  return /*#__PURE__*/_react["default"].createElement(_Header["default"], (0, _extends2["default"])({
    as: "h3"
  }, props), children);
};

Title.propTypes = {
  children: _propTypes["default"].node
};

var ButtonGroup = function ButtonGroup(_ref4) {
  var children = _ref4.children,
      props = (0, _objectWithoutProperties2["default"])(_ref4, _excluded4);
  return /*#__PURE__*/_react["default"].createElement("div", props, children);
};

ButtonGroup.propTypes = {
  children: _propTypes["default"].node
};

var Button = function Button(_ref5) {
  var label = _ref5.label,
      children = _ref5.children,
      buttonType = _ref5.buttonType,
      variant = _ref5.variant,
      props = (0, _objectWithoutProperties2["default"])(_ref5, _excluded5);
  return /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    color: variant === 'primary' ? 'blue' : undefined
  }, props), label || children);
};

Button.propTypes = {
  children: _propTypes["default"].node,
  label: _propTypes["default"].node,
  variant: _propTypes["default"].string,
  buttonType: _propTypes["default"].string
};

var MuiFormTemplate = function MuiFormTemplate(props) {
  return /*#__PURE__*/_react["default"].createElement(_formTemplate["default"], (0, _extends2["default"])({
    FormWrapper: Form,
    Button: Button,
    ButtonGroup: ButtonGroup,
    Title: Title,
    Description: Description
  }, props));
};

var _default = MuiFormTemplate;
exports["default"] = _default;